'use strict'

/* eslint-disable no-new-func */

const common = require('./common')

const or = function () {
  const functions = Array.prototype.slice.call(arguments)
  let code = `
    "use strict"
  `
  let returnCode = `
      return`

  functions.forEach((func, index) => {
    if (func.validators) {
      func = common.toFunction(func.validators)
    }
    code += `
      const validate${index} = ${func.toString()}
    `
    returnCode += ` validate${index}(orValue)`
    if (index < functions.length - 1) {
      returnCode += ' ||'
    }
  })

  code += `
    function orify (orValue) {${returnCode}`

  code += `
    }
    return orify
  `
  return new Function(code)()
}

module.exports = or
